Package com.sas.metadata.remote

# Interface Timestamp

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `Remote`, `Root`, `SecondaryType`

public interface Timestamp extends SecondaryType
This object contains a timestamp and the role of the timestamp.

Attributes of Timestamp are:

- `DateandTime`
- `TimeZone`
- `TimestampRole`

Associations of Timestamp are:

- `Objects`

## Usage

To create an instance of this Timestamp, use the `factory` create methods.
Example: create a Timestamp with name "Timestamp_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Timestamp myObject = (Timestamp) factory.createComplexMetadataObject(objectStore, "Timestamp_Object", MetadataObjects.TIMESTAMP, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_OBJECTS_NAME`
  Constant used for the name of the Objects association.
  `static final String`
  `ATTRIBUTE_DATEANDTIME_NAME`
  Constant used for the name of the DateandTime attribute.
  `static final String`
  `ATTRIBUTE_TIMESTAMPROLE_NAME`
  Constant used for the name of the TimestampRole attribute.
  `static final String`
  `ATTRIBUTE_TIMEZONE_NAME`
  Constant used for the name of the TimeZone attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `double`
  `getDateandTime()`
  Gets the `double` value of `DateandTime`
  `int`
  `getDateandTimeState()`
  Gets the Metadata State of `DateandTime`
  `AssociationList`
  `getObjects()`
  Gets the AssociationList of `Objects`
  `AssociationList`
  `getObjects(boolean fGoToServer)`
  Gets the Associationlist of `Objects`
  `String`
  `getTimestampRole()`
  Gets the `String` value of `TimestampRole`
  `int`
  `getTimestampRoleMaxLength()`
  Gets the maximum length of `TimestampRole`
  `int`
  `getTimestampRoleState()`
  Gets the Metadata State of `TimestampRole`
  `String`
  `getTimeZone()`
  Gets the `String` value of `TimeZone`
  `int`
  `getTimeZoneMaxLength()`
  Gets the maximum length of `TimeZone`
  `int`
  `getTimeZoneState()`
  Gets the Metadata State of `TimeZone`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `Objects`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setDateandTime(double inDateandTime)`
  Sets the `DateandTime` value and sets the state to MetadataState.LOCAL.
  `void`
  `setDateandTime(double inDateandTime, int state)`
  Sets the `DateandTime` Metadata State.
  `void`
  `setDateandTime(String inDateandTime)`
  Sets the `DateandTime` value and sets the state to MetadataState.LOCAL
  `void`
  `setDateandTime(String inDateandTime, int state)`
  Sets the `DateandTime` value and Metadata State.
  `void`
  `setDateandTimeState(int state)`
  Sets the Metadata State of `DateandTime`.
  `void`
  `setObjects(AssociationList list)`
  Sets the `Objects` list to be `list`.
  `void`
  `setObjects(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setTimestampRole(String inTimestampRole)`
  Sets the `TimestampRole` value and sets the state to MetadataState.LOCAL.
  `void`
  `setTimestampRole(String inTimestampRole, int state)`
  Sets the `TimestampRole` Metadata State.
  `void`
  `setTimestampRoleState(int state)`
  Sets the Metadata State of `TimestampRole`.
  `void`
  `setTimeZone(String inTimeZone)`
  Sets the `TimeZone` value and sets the state to MetadataState.LOCAL.
  `void`
  `setTimeZone(String inTimeZone, int state)`
  Sets the `TimeZone` Metadata State.
  `void`
  `setTimeZoneState(int state)`
  Sets the Metadata State of `TimeZone`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_DATEANDTIME_NAME

    static final String ATTRIBUTE_DATEANDTIME_NAME
    Constant used for the name of the DateandTime attribute.

    DateandTime: This double contains a SAS datetime value.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_TIMEZONE_NAME

    static final String ATTRIBUTE_TIMEZONE_NAME
    Constant used for the name of the TimeZone attribute.

    TimeZone: This is the timezone used with the DateandTime attribute.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_TIMESTAMPROLE_NAME

    static final String ATTRIBUTE_TIMESTAMPROLE_NAME
    Constant used for the name of the TimestampRole attribute.

    TimestampRole: This is the role of the Timestamp. Example roles are: Create, Modify, Expire.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_OBJECTS_NAME

    static final String ASSOCIATION_OBJECTS_NAME
    Constant used for the name of the Objects association.

    Objects: The objects associated with this timestamp.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `Objects`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDateandTime

    double getDateandTime() throws RemoteException
    Gets the `double` value of `DateandTime`
    Returns:
      The `DateandTime`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getDateandTimeState

    int getDateandTimeState() throws RemoteException
    Gets the Metadata State of `DateandTime`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTimeZone

    String getTimeZone() throws RemoteException
    Gets the `String` value of `TimeZone`
    Returns:
      The `TimeZone`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTimeZoneState

    int getTimeZoneState() throws RemoteException
    Gets the Metadata State of `TimeZone`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTimeZoneMaxLength

    int getTimeZoneMaxLength() throws RemoteException
    Gets the maximum length of `TimeZone`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTimestampRole

    String getTimestampRole() throws RemoteException
    Gets the `String` value of `TimestampRole`
    Returns:
      The `TimestampRole`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTimestampRoleState

    int getTimestampRoleState() throws RemoteException
    Gets the Metadata State of `TimestampRole`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTimestampRoleMaxLength

    int getTimestampRoleMaxLength() throws RemoteException
    Gets the maximum length of `TimestampRole`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getObjects

    AssociationList getObjects() throws RemoteException, MdException
    Gets the AssociationList of `Objects`
    Returns:
      Returns the AssociationList of `Objects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getObjects

    AssociationList getObjects(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Objects`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Objects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setDateandTime

    void setDateandTime(double inDateandTime) throws RemoteException
    Sets the `DateandTime` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inDateandTime` - double
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDateandTime

    void setDateandTime(double inDateandTime, int state) throws RemoteException
    Sets the `DateandTime` Metadata State.
    Parameters:
      `inDateandTime` - double
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDateandTime

    void setDateandTime(String inDateandTime) throws RemoteException
    Sets the `DateandTime` value and sets the state to MetadataState.LOCAL
    Parameters:
      `inDateandTime` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDateandTime

    void setDateandTime(String inDateandTime, int state) throws RemoteException
    Sets the `DateandTime` value and Metadata State.
    Parameters:
      `inDateandTime` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setDateandTimeState

    void setDateandTimeState(int state) throws RemoteException
    Sets the Metadata State of `DateandTime`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTimeZone

    void setTimeZone(String inTimeZone) throws RemoteException
    Sets the `TimeZone` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inTimeZone` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTimeZone

    void setTimeZone(String inTimeZone, int state) throws RemoteException
    Sets the `TimeZone` Metadata State.
    Parameters:
      `inTimeZone` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTimeZoneState

    void setTimeZoneState(int state) throws RemoteException
    Sets the Metadata State of `TimeZone`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTimestampRole

    void setTimestampRole(String inTimestampRole) throws RemoteException
    Sets the `TimestampRole` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inTimestampRole` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTimestampRole

    void setTimestampRole(String inTimestampRole, int state) throws RemoteException
    Sets the `TimestampRole` Metadata State.
    Parameters:
      `inTimestampRole` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTimestampRoleState

    void setTimestampRoleState(int state) throws RemoteException
    Sets the Metadata State of `TimestampRole`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setObjects

    void setObjects(AssociationList list) throws RemoteException
    Sets the `Objects` list to be `list`. Objects of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setObjects

    void setObjects(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.